package com.flashvisions.mobile.android.extensions.system.functions;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Context;
import android.os.Build;
import android.telephony.TelephonyManager;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;
import com.adobe.fre.FREWrongThreadException;
import com.flashvisions.mobile.android.extensions.system.SystemNFOExtensionContext;

public class GetDeviceIdentityFunction implements FREFunction {

	@Override
	public FREObject call(FREContext context, FREObject[] arg1) {
		
		FREObject result = null;
		JSONObject obj = null;

		SystemNFOExtensionContext nfo = (SystemNFOExtensionContext) context;
		Activity a = nfo.getActivity();
		TelephonyManager telephonyManager = (TelephonyManager)a.getSystemService(Context.TELEPHONY_SERVICE);
		
		try {
			obj = new JSONObject();
			//obj.put("IMEI",telephonyManager.getDeviceId());
			obj.put("IMSI",telephonyManager.getSubscriberId());
			obj.put("IMEISV",telephonyManager.getDeviceSoftwareVersion());
			//obj.put("SERIAL",Build.SERIAL);
			obj.put("MODEL",Build.MODEL);
			obj.put("PHONENUMBER", telephonyManager.getLine1Number());
			
			result = FREObject.newObject(String.valueOf(obj));
		} catch (FREWrongThreadException e) {
			e.printStackTrace();
		}catch (JSONException e1) {
			e1.printStackTrace();
		}finally{
			obj = null;
			telephonyManager = null;
		}

		return result;
	}

}
